/* USER CODE BEGIN Header */
/**
 ******************************************************************************
 * @file           : main.h
 * @brief          : Header for main.c file.
 *                   This file contains the common defines of the application.
 ******************************************************************************
 * @attention
 *
 * <h2><center>&copy; Copyright (c) 2022 STMicroelectronics.
 * All rights reserved.</center></h2>
 *
 * This software component is licensed by ST under BSD 3-Clause license,
 * the "License"; You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at:
 *                        opensource.org/licenses/BSD-3-Clause
 *
 ******************************************************************************
 */
/* USER CODE END Header */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __MAIN_H
#define __MAIN_H

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "stm32g4xx_hal.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */

/* USER CODE END Includes */

/* Exported types ------------------------------------------------------------*/
/* USER CODE BEGIN ET */
typedef struct {
  uint8_t errorcode;
  uint8_t errorarg[8];
} AMSErrorHandle;
/* USER CODE END ET */

/* Exported constants --------------------------------------------------------*/
/* USER CODE BEGIN EC */

/* USER CODE END EC */

/* Exported macro ------------------------------------------------------------*/
/* USER CODE BEGIN EM */

/* USER CODE END EM */

/* Exported functions prototypes ---------------------------------------------*/
void Error_Handler(void);

/* USER CODE BEGIN EFP */
void AMS_Error_Handler(AMSErrorHandle);
/* USER CODE END EFP */

/* Private defines -----------------------------------------------------------*/
#define Slaves_Enable_Pin GPIO_PIN_13
#define Slaves_Enable_GPIO_Port GPIOC
#define BOOT0_FF_CLK_Pin GPIO_PIN_14
#define BOOT0_FF_CLK_GPIO_Port GPIOC
#define BOOT0_FF_DATA_Pin GPIO_PIN_15
#define BOOT0_FF_DATA_GPIO_Port GPIOC
#define Relay_Supply_Voltage_Pin GPIO_PIN_0
#define Relay_Supply_Voltage_GPIO_Port GPIOA
#define Pos_AIR_Current_Pin GPIO_PIN_1
#define Pos_AIR_Current_GPIO_Port GPIOA
#define Neg_AIR_Current_Pin GPIO_PIN_2
#define Neg_AIR_Current_GPIO_Port GPIOA
#define PreCharge_AIR_Current_Pin GPIO_PIN_3
#define PreCharge_AIR_Current_GPIO_Port GPIOA
#define SC_Supply_Voltage_Pin GPIO_PIN_4
#define SC_Supply_Voltage_GPIO_Port GPIOA
#define AMS_ERROR_Pin GPIO_PIN_0
#define AMS_ERROR_GPIO_Port GPIOB
#define IMD_Error_Pin GPIO_PIN_1
#define IMD_Error_GPIO_Port GPIOB
#define AMS_Error_LED_Pin GPIO_PIN_2
#define AMS_Error_LED_GPIO_Port GPIOB
#define Volt_Error_CPU_Pin GPIO_PIN_10
#define Volt_Error_CPU_GPIO_Port GPIOB
#define Positive_Side_Error_CPU_Pin GPIO_PIN_11
#define Positive_Side_Error_CPU_GPIO_Port GPIOB
#define Neg_Side_Error_CPU_Pin GPIO_PIN_12
#define Neg_Side_Error_CPU_GPIO_Port GPIOB
#define HV_Inactive_CPU_Pin GPIO_PIN_13
#define HV_Inactive_CPU_GPIO_Port GPIOB
#define Neg_AIR_Open_CPU_Pin GPIO_PIN_14
#define Neg_AIR_Open_CPU_GPIO_Port GPIOB
#define High_Side_Open_CPU_Pin GPIO_PIN_15
#define High_Side_Open_CPU_GPIO_Port GPIOB
#define Inter_STM_CS_Pin GPIO_PIN_8
#define Inter_STM_CS_GPIO_Port GPIOA
#define Inter_STM_IRQ_Pin GPIO_PIN_9
#define Inter_STM_IRQ_GPIO_Port GPIOA
#define Status_LED_Pin GPIO_PIN_10
#define Status_LED_GPIO_Port GPIOA
#define IMD_Error_LED_Pin GPIO_PIN_3
#define IMD_Error_LED_GPIO_Port GPIOB
#define PreCharge_Control_Pin GPIO_PIN_5
#define PreCharge_Control_GPIO_Port GPIOB
#define AIR_Positive_Control_Pin GPIO_PIN_6
#define AIR_Positive_Control_GPIO_Port GPIOB
#define AIR_negative_Control_Pin GPIO_PIN_7
#define AIR_negative_Control_GPIO_Port GPIOB
/* USER CODE BEGIN Private defines */

/* USER CODE END Private defines */

#ifdef __cplusplus
}
#endif

#endif /* __MAIN_H */
